#include <bits/stdc++.h>

using namespace std;
using ll = long long;

vector<int> rotateR(vector<int> a) {
    return {a[4], a[0], a[2], a[3], a[5], a[1]};
}

vector<int> rotateU(vector<int> a) {
    return {a[3], a[1], a[0], a[5], a[4], a[2]};
}

struct state {
    int i, j;
    vector<int> c;
    vector<int> ids;
};

bool operator<(const state &a, const state &b) {
    return tie(a.i, a.j, a.c) < tie(b.i, b.j, b.c);
}

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> a(n, vector<int>(n));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> a[i][j];
        }
    }
    queue<state> pq;
    set<state> used;
    pq.push({0, 0, vector<int>{a[0][0], -1, -1, -1, -1, -1}, vector<int>{0, 1, 2, 3, 4, 5}});
    used.insert(pq.front());
    while (!pq.empty()) {
        state s = pq.front();
        pq.pop();
        if (s.i == n - 1 && s.j == n - 1) {
            cout << "Yes\n";
            vector<int> realC(6);
            for (int i = 0; i < 6; i++) {
                realC[s.ids[i]] = s.c[i];
            }
            for (int c: realC) {
                if (c == -1) {
                    cout << 1;
                } else {
                    cout << c;
                }
                cout << " ";
            }
            cout << "\n";
            return;
        }

        if (s.j + 1 < n) {
            auto cr = rotateR(s.c);
            if (cr[0] == -1 || cr[0] == a[s.i][s.j + 1]) {
                cr[0] = a[s.i][s.j + 1];
                state nxt{s.i, s.j + 1, cr, rotateR(s.ids)};
                if (used.insert(nxt).second) {
                    pq.push(nxt);
                }
            }
        }
        if (s.i + 1 < n) {
            auto cr = rotateU(s.c);
            if (cr[0] == -1 || cr[0] == a[s.i + 1][s.j]) {
                cr[0] = a[s.i + 1][s.j];
                state nxt{s.i + 1, s.j, cr, rotateU(s.ids)};
                if (used.insert(nxt).second) {
                    pq.push(nxt);
                }
            }
        }
    }
    cout << "No\n";
}

int main() {
    ios_base::sync_with_stdio(0);
    cout.tie(0);

    int test;
    cin >> test;
    while (test--) {
        solve();
    }

    return 0;
}