#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
#include<set>
#include<map>
#include<cmath>
using namespace std;
#define int long long
#define double long double
const int _1e9 = 1'000'000'000;
const double PI = M_PI;

double ang(pair<int, int> a, pair<int, int> b) {
	double dx = b.first - a.first, dy = b.second - a.second;
	return atan2(dy, dx);
}

double dist(pair<int, int> a, pair<int, int> b) {
	double dx = b.first - a.first, dy = b.second - a.second;
	return sqrt(dx * dx + dy * dy);
}

const double eps = 1e-9;

bool in(pair<int, int> point, pair<int, int> a, pair<int, int> b) {
	//cout << point.first << ' ' << point.second << ' ' << a.first << ' ' << a.second << ' ' << b.first << ' ' << b.second << ' ' << dist(a, b) << ' ' << dist(a, point) << ' ' << dist(b, point) << '\n';
	//cout << dist(a, b) << ' ' << dist(a, point) + dist(b, point) << '\n';
	return dist(a, b) + eps >= dist(a, point) + dist(b, point) && (a.first != point.first || a.second != point.second) && (b.first != point.first || b.second != point.second);
}

void solve() {
	int n;
	cin >> n;
	set<pair<int, int>> pointsSet;
	vector<vector<int>> a(n, vector<int>(4));
	for (int i = 0; i < n; ++i) {
		int x1, y1, x2, y2;
		cin >> x1 >> y1 >> x2 >> y2;
		a[i] = { x1, y1, x2, y2 };
		pointsSet.insert({ x1, y1 });
		pointsSet.insert({ x2, y2 });
	}
	map<pair<int, int>, int> id;
	int I = 0;
	int m = pointsSet.size();
	vector<pair<int, int>> points;
	for (auto p : pointsSet) {
		id[p] = I++;
		points.push_back(p);
	}
	for (int i = 0; i < m; ++i) {
		//cout << points[i].first << ' ' << points[i].second << '\n';
	}
	vector<pair<int, int>> segments(n);
	for (int i = 0; i < n; ++i) {
		int i1 = id[{a[i][0], a[i][1]}], i2 = id[{a[i][2], a[i][3]}];
		segments[i] = { i1, i2 };
	}
	vector<vector<double>> out(m);
	for (int i = 0; i < n; ++i) {
		int j1 = segments[i].first, j2 = segments[i].second;
		double ang1 = ang(points[j1], points[j2]), ang2 = ang(points[j2], points[j1]);
		//cout << ang1 << ' ' << ang2 << '\n';
		out[j1].push_back(ang1);
		out[j2].push_back(ang2);
	}
	for (int i = 0; i < m; ++i) {
		sort(out[i].begin(), out[i].end());
	}
	int ans = 0;
	for (int i = 0; i < n; ++i) {
		pair<int, int> segment = segments[i];
		int i1 = segment.first, i2 = segment.second;
		double ang1 = ang(points[i1], points[i2]);
		double ang2 = ang(points[i2], points[i1]);
		//cout << "a " << points[i1].first << ' ' << points[i1].second << ' ' << points[i2].first << ' ' << points[i2].second << '\n';
		if (ang2 < eps) {
			ang2 += 2 * PI;
		}
		if (ang1 < eps) {
			ang1 += PI, ang2 += PI;
		}
		cout << ang1 << ' ' << ang2 << '\n';
		for (auto point : points) {
			if (in(point, points[i1], points[i2])) {
				int pid = id[point];
				//cout << point.first << ' ' << point.second << ' ' << pid << '\n';
				int cnt1 = 0, cnt2 = 0;
				for (double ang : out[pid]) {
					if (ang < 0) {
						ang += 2 * PI;
					}
					//cout << "b " << ang1 << ' ' << ang2 << ' ' << ang << '\n';
					if (abs(ang - ang1) < eps || abs(ang - ang2) < eps) {
						continue;
					}
					if (ang > ang1 && ang < ang2) {
						cnt1++;
					} else {
						cnt2++;
					}
				}
				ans += cnt1 * (cnt1 - 1) / 2;
				ans += cnt2 * (cnt2 - 1) / 2;
				for (int j = 0; j < out[pid].size();) {
					double ang = out[pid][j];
					if (abs(ang - ang1) < eps || abs(ang - ang2) < eps) {
						j++;
						continue;
					}
					int j1 = j;
					while (j1 < out[pid].size() && abs(out[pid][j1] - out[pid][j]) < eps) {
						j1++;
					}
					int cnt = j1 - j;
					ans -= cnt * (cnt - 1) / 2;
					j = j1;
				}
				//cout << cnt1 << ' ' << cnt2 << '\n';
			}
		}
	}
	cout << ans << '\n';
	/*
	1
		5
		0 0 0 10
		0 5 3 10
		0 5 3 0
		0 5 7 4
		0 5 6 2
		*/
}

int32_t main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	int t;
	cin >> t;
	for (int i = 0; i < t; ++i) {
		solve();
	}

	return 0;
}