#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>

#define lint int64_t
#define int int64_t

using namespace std;

int line_solve(string& s) {
    int last = -1;
    char last_type = '.';

    bool gg = false;
    int sum = 0;

    for (int cur = 0; cur <= s.size(); cur++) {
        char cur_type = (cur == s.size()) ? '.' : s[cur];

        if (cur_type == '?') continue;

        if (last + 1 < cur) {
            int black_cnt = (last_type == '#') + (cur_type == '#');
            if (black_cnt == 2) gg = true;
            else if (black_cnt == 1) {}
            else if (black_cnt == 0) sum++;
        }
        last = cur;
        last_type = cur_type;
    }

    if (gg) return -1;
    return sum;
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

#ifdef _LOCAL
    freopen("../input.txt", "r", stdin);
//    freopen(stdout, 'w', "output.txt");
#endif

    int n;
    cin >> n;
    vector<string> field(n);
    for (auto& s : field) cin >> s;

    int sum = 0;
    bool gg = false;
    for (int i = 0; i < n; i++) {
        {
            int x = line_solve(field[i]);
            if (x == -1) gg = true;
            sum += x;
        }

        string col;
        for (int j = 0; j < n; j++) col.push_back(field[j][i]);

        {
            int x = line_solve(col);
            if (x == -1) gg = true;
            sum += x;
        }
    }

    if (gg) cout << 0;
    else {
        cerr << sum << endl;

        const int mod = 998244353ll;
        lint ans = 1;
        for (int i = 0; i < sum; i++) {
            ans = (ans * 2) % mod;
        }
        cout << ans << endl;
    }




    return 0;
}