#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>

#define lint int64_t

using namespace std;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

#ifdef _LOCAL
    freopen("../input.txt", "r", stdin);
//    freopen(stdout, 'w', "output.txt");
#endif

    int n;
    cin >> n;
    vector<int> a(n);
    vector<int> a_pos(n);
    for (int i = 0; i < n; i++) {
        int x;
        cin >> x;
        --x;
        a[i] = x;
        a_pos[x] = i;
    }

    vector<int> b(n);
    vector<int> b_pos(n, -1);
    for (int i = 0; i < n; i++) {
        int x;
        cin >> x;
        --x;
        b[i] = x;
        if (b_pos[x] != -1){
            cout << -1;
            return 0;
        }
        b_pos[x] = i;
    }

    vector<int> ans;
    auto swapa = [&](int i) {
//        for (auto& x : a) cerr << x << ' ';
//        cerr << endl;
//        cerr << i << '\n';
        if (abs(a[i] - a[i+1]) < 2) {
            return false;
        }
        swap(a_pos[a[i]], a_pos[a[i+1]]);
        swap(a[i], a[i+1]);
        ans.push_back(i);
        return true;
    };

    for (int pos_to = 0; pos_to < n; pos_to++) {
        int cube = b[pos_to];
        int pos_from = a_pos[cube];

        for (pos_from; pos_from > pos_to; pos_from--) {
            if (!swapa(pos_from - 1)) {
                cout << -1;
                return 0;
            }
        }
    }

    cout << ans.size() << '\n';
    for (auto& i : ans) cout << i + 1 << ' ';


    return 0;
}
