#include <iostream>
#include <bits/stdc++.h>

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)

using namespace std;

const int N = 200200;
int arr[N];
int tree[4 * N];

int get_min(int v, int tl, int tr, int l, int r) {
    if (tr <= l || r <= tl) return numeric_limits<int>::max();
    if (l <= tl && tr <= r) return tree[v];
    int tm = (tl + tr) / 2;
    return min(get_min(v * 2, tl, tm, l, r), get_min(v * 2 + 1, tm, tr, l, r));
}

void build(int v, int l, int r) {
    if (l + 1 == r) {
        tree[v] = arr[l];
    } else {
        int m = (l + r) / 2;
        build(v * 2, l, m);
        build(v * 2 + 1, m, r);
        tree[v] = min(tree[v * 2], tree[v * 2 + 1]);
    }
}

void update(int v, int l, int r, int pos) {
    if (l + 1 == r) {
        tree[v] = arr[l];
    } else {
        int m = (l + r) / 2;
        if (pos < m) {
            update(v * 2, l, m, pos);
        } else {
            update(v * 2 + 1, m, r, pos);
        }
        tree[v] = min(tree[v * 2], tree[v * 2 + 1]);
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    int ans = 0;
    int mn = numeric_limits<int>::max();
    for (int i = 0; i < n; i++) {
        cin >> arr[i];
        mn = min(mn, arr[i]);
        ans += mn;
    }
    n++;

    build(1, 0, n);
    int q;
    cin >> q;
    cout << ans << "\n";
    for (int i = 0; i < q; i++) {
        int type, x;
        cin >> type >> x;
        if (type == 1) {
            int prev_min = get_min(1, 0, n, 0, x);
            arr[x] += 1;
            update(1, 0, n, x);
            if (prev_min >= arr[x]) {
                int left = x, right = n;
                while (left + 1 < right) {
                    int med = (left + right) / 2;
                    if (get_min(1, 0, n, x, med) < arr[x]) {
                        right = med;
                    } else {
                        left = med;
                    }
                }
                ans += left - x;
            }
        } else {
            int prev_min = get_min(1, 0, n, 0, x);
            arr[x] -= 1;
            update(1, 0, n, x);
            if (arr[x] < prev_min) {
                int left = x + 1, right = n;
                while (left + 1 < right) {
                    int med = (left + right) / 2;
                    if (get_min(1, 0, n, x + 1, med) <= arr[x]) {
                        right = med;
                    } else {
                        left = med;
                    }
                }
                ans -= left - x;
            }
        }
        cout << ans << "\n";
    }
}


/*
C:\work\untitled\cmake-build-debug\untitled.exe
5
3 4 1 2 0
5
8
1 2
10
2 1
9
1 1
9
2 2
7

 */