#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

const int INF = 1e9;

struct SegmentTree {
    int n;
    vector<int> tree, lazy;

    SegmentTree(vector<int> v) {
        n = v.size();
        tree.resize(4 * n, INF);
        lazy.resize(4 * n);
        build(0, 0, n - 1, v);
    }

    void build(int a, int l, int r, vector<int> &v) {
        if (l == r) {
            tree[a] = v[l];
            return;
        }
        int m = (l + r) / 2;
        build(a * 2 + 1, l, m, v);
        build(a * 2 + 2, m + 1, r, v);
        tree[a] = min(tree[a * 2 + 1], tree[a * 2 + 2]);
    }

    void push(int a) {
        tree[a] += lazy[a];
        if (a * 2 + 2 < 4 * n) {
            lazy[a * 2 + 1] += lazy[a];
            lazy[a * 2 + 2] += lazy[a];
        }
        lazy[a] = 0;
    }

    void add(int a, int l, int r, int L, int R, int x) {
        push(a);
        if (l > R || r < L) {
            return;
        }
        if (l >= L && r <= R) {
            lazy[a] += x;
            push(a);
            return;
        }
        int m = (l + r) / 2;
        add(a * 2 + 1, l, m, L, R, x);
        add(a * 2 + 2, m + 1, r, L, R, x);
        tree[a] = min(tree[a * 2 + 1], tree[a * 2 + 2]);
    }

    int getsub(int a, int l, int r, int p) {
        push(a);
        if (r < p) {
            return 0;
        }
        if (l >= p && tree[a] > 0) {
            lazy[a] -= 1;
            push(a);
            return r - l + 1;
        }
        if (l == r) {
            return 0;
        }
        int m = (l + r) / 2;
        int g1 = getsub(a * 2 + 1, l, m, p);
        int g2 = 0;
        //cout << "a: " << a << ", l: " << l << ", r: " << r << ", g1: " << g1 << '\n';
        if (g1 >= m - max(l, p) + 1) {
            g2 = getsub(a * 2 + 2, m + 1, r, p);
        }
        tree[a] = min(tree[a * 2 + 1], tree[a * 2 + 2]);
        return g1 + g2;
    }

    int get(int a, int l, int r, int p) {
        push(a);
        if (l == r) {
            return tree[a];
        }
        int m = (l + r) / 2;
        if (p <= m) {
            return get(a * 2 + 1, l, m, p);
        } else {
            return get(a * 2 + 2, m + 1, r, p);
        }
    }

    void add(int l, int r, int x) {
        add(0, 0, n - 1, l, r, x);
    }

    int getsub(int p) {
        return getsub(0, 0, n - 1, p);
    }

    int get(int p) {
        return get(0, 0, n - 1, p);
    }
};

void solve() {
    int n; cin >> n;
    vector<int> v(n + 1), f(n + 1);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }
    int prev = v[0], ind = 0;
    long long ans = 0;
    set<int> segs;
    for (int i = 1; i < n; i++) {
        if (v[i] < prev) {
            ans += (long long) i * (prev - v[i]);
            //cout << "ans: " << ans << '\n';
            f[i - 1] += prev - v[i];
            ind = i;
            prev = v[i];
        }
        v[i] -= prev;
        if (f[i - 1] > 0) {
            segs.insert(i - 1);
        }
    }
    SegmentTree st(v);
    int q; cin >> q;
    cout << ans << '\n';
    for (int i = 0; i < q; i++) {
        //cout << "i: " << i << '\n';
        int p, c; cin >> p >> c;
        if (p == 1) {
            if (c == 0) {
                ans++;
                if (f[0] == 0) {
                    segs.insert(0);
                }
                f[0]++;
            } else {
                st.add(c, c, 1);
                if (f[c - 1] > 0) {
                    int l = st.getsub(c);
                    //cout << "l: " << l << '\n';
                    if (f[c - 1] == 1) {
                        segs.erase(c - 1);
                    }
                    f[c - 1]--;
                    if (f[c + l - 1] == 0) {
                        segs.insert(c + l - 1);
                    }
                    f[c + l - 1]++;
                    ans += l;
                }
            }
        } else {
            if (c == 0) {
                if (f[0] == 1) {
                    segs.erase(0);
                }
                ans--;
            } else if (st.get(c) > 0) {
                st.add(c, c, -1);
            } else {
                int j = *segs.lower_bound(c);
                if (f[j] == 1) {
                    segs.erase(j);
                }
                f[j]--;
                if (f[c - 1] == 0) {
                    segs.insert(c - 1);
                }
                f[c - 1]++;
                st.add(c + 1, j, 1);
                ans -= j - c + 1;
            }
        }
        cout << ans << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0);
    //int t; cin >> t; while(t--)
    solve();
    return 0;
}
