#include <bits/stdc++.h>
//#include "ext/pb_ds/assoc_container.hpp"
//#include "ext/pb_ds/tree_policy.hpp"

//using namespace __gnu_pbds;
using namespace std;

typedef double ld;

#define int long long
#define ALL(x) (x).begin(), (x).end()
//#define ordered_set tree<int, null_type, less, rb_tree_tag, tree_order_statistics_node_update>

struct seg_tree {
    struct Node {
        int value;
    };

    vector<Node> a;
    int size;

    static int upper_power(int x) {
        int res = 1;
        while (res < x) {
            res *= 2;
        }
        return res;
    }

    void calc(int i) {
        a[i].value = min(a[2 * i].value, a[2 * i + 1].value);
    }

    seg_tree(const vector<int>& values) : size(upper_power(values.size())) {
        a.resize(2 * size + 1);
        for (int i = 0; i < values.size(); ++i) {
            a[size + i].value = values[i];
        }
        for (int i = size - 1; i > 0; --i) {
            calc(i);
        }
    }


    void add(int i, int x) {
        add(1, 0, size, i, x);
    }

    void add(int v, int vl, int vr, int i, int x) {
        if (vl > i || vr <= i) {
            return;
        }
        if (vr == vl + 1) {
            a[v].value += x;
            return;
        }
        int m = (vl + vr) / 2;
        add(2 * v, vl, m, i, x);
        add(2 * v + 1, m, vr, i, x);
        calc(v);
    }

    int get(int l, int r) {
        return get(1, 0, size, l, r);
    }

    int get(int v, int vl, int vr, int l, int r) {
        if (vl >= r || vr <= l) {
            return 1e9;
        }
        if (l <= vl && vr <= r) {
            return a[v].value;
        }
        int m = (vl + vr) / 2;
        return min(get(2 * v, vl, m, l, r), get(2 * v + 1, m, vr, l, r));
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
//#ifdef LOCAL
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
//#endif

    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    int ans = 0, last = 1e9;
    for (int i = 0; i < n; ++i) {
        last = min(last, a[i]);
        ans += last;
    }
    seg_tree min_tree(a);
    cout << ans << '\n';
    int q;
    cin >> q;
    while (q--) {
        int p, v;
        cin >> p >> v;
        if (p == 1) {
            a[v] += 1;
            min_tree.add(v, 1);
            if (v == 0 || min_tree.get(0,v) >= a[v]) {
                int l = v, r = n;
                while (r - l > 1) {
                    int m = (l + r) / 2;
                    if (min_tree.get(v + 1, m + 1) < a[v]) {
                        r = m;
                    } else {
                        l = m;
                    }
                }
                ans += r - v;
            }
        } else {
            a[v] -= 1;
            min_tree.add(v, -1);
            if (v == 0 || min_tree.get(0,v) > a[v]) {
                int l = v, r = n;
                while (r - l > 1) {
                    int m = (l + r) / 2;
                    if (min_tree.get(v + 1, m + 1) <= a[v]) {
                        r = m;
                    } else {
                        l = m;
                    }
                }
                ans -= r - v;
            }
        }
        cout << ans << '\n';
    }
    return 0;
}
