#include <bits/stdc++.h>
#ifdef LOCAL
#include "debug.h"
#endif
using namespace std;

#define int long long

struct segment {
    int x, y;
    int xx, yy;

    int dist() const {
        return abs(xx - x) + abs(yy - y);
    }

    bool operator<(const segment& other) const {
        return dist() > other.dist();
    }

    bool intersect(const segment& other) const {
        if (x == xx && other.x == other.xx) {
            return false;
            return yy > other.y && yy < other.yy;
        } else if (x == xx && other.y == other.yy) {
            return y <= other.y && other.y < yy &&
                    other.x <= xx && xx < other.xx;
        } else if (y == yy && other.x == other.xx) {
            return x <= other.x && other.x < xx &&
                   other.y <= yy && yy < other.yy;
        } else if (y == yy && other.y == other.yy) {
            return false;
            return xx > other.x && xx < other.xx;
        } else {
            assert(false);
        }
    }
};

void solve() {
//    segment aa{0, 0, 2, 0};
//    segment bb{0, 0, 0, 1};
//    cout << aa.intersect(bb) << endl << endl;

    int n, m;
    cin >> n >> m;
    vector<string> a(n);
    for (auto& x : a) {
        cin >> x;
    }
    multiset<segment> s;
    for (int i = 0; i < n; i++) {
        int len = 0;
        for (int j = 0; j < m; ++j) {
            if (a[i][j] == '.') {
                len++;
            } else if (len > 0) {
                s.insert({i, j - len, i, j});
                len = 0;
            }
        }
        if (len > 0) {
//            cout << "len = " << len << endl;
            s.insert({i, m - len, i, m});
            len = 0;
        }
    }
    for (int j = 0; j < m; ++j) {
        int len = 0;
        for (int i = 0; i < n; ++i) {
            if (a[i][j] == '.') {
                len++;
            } else if (len > 0) {
                s.insert({i - len, j, i, j});
                len = 0;
            }
        }
        if (len > 0) {
            s.insert({n - len, j, n, j});
            len = 0;
        }
    }
//    for (const auto& seg : s) {
//        cout << seg.dist() << "\n";
//    }
//    cout << "\n";
    if (s.size() == 0) {
        cout << "0\n";
        return;
    }
    segment first;
    if (s.size() >= 1) {
        first = *s.begin();
        s.erase(s.begin());
    }
    if (s.size() == 0) {
        cout << first.dist() << "\n";
        return;
    }
    segment second = *s.begin();
    s.erase(s.begin());
    if (!first.intersect(second)) {
        cout << first.dist() + second.dist() << "\n";
        return;
    }
    auto get_max_with_third = [&]() {
        // all cases below can be not optimal
        segment third;
        if (s.size() >= 1) {
            third = *s.begin();
            s.erase(s.begin());
        } else {
            return 0LL;
        }
//        cout << third.x << " " << third.xx << " " << third.y << " " << third.yy << endl;
        if (!first.intersect(third)) {
            return first.dist() + third.dist();
        }
//        cout << first.dist() << endl;
//        cout << second.dist() << endl;
//        cout << third.dist() << endl;
        assert(!second.intersect(third));
        int cur_opt = second.dist() + third.dist();
        while (s.size()) {
            segment kth = *s.begin();
            s.erase(s.begin());
            if (!first.intersect(kth)) {
                return max(cur_opt, first.dist() + kth.dist());
            }
        }
        return cur_opt;
    };
    int cur_opt = get_max_with_third();
//    cout << "cur_opt = " << cur_opt << endl;
    auto get_max_T = [&]() {
        vector<vector<int>> pref_col(n, vector<int>(m));
        vector<vector<int>> suff_col(n, vector<int>(m));
        vector<vector<int>> pref_row(n, vector<int>(m));
        vector<vector<int>> suff_row(n, vector<int>(m));
        for (int i = 0; i < n; ++i) {
            pref_row[i][0] = (a[i][0] == '.');
            for (int j = 1; j < m; ++j) {
                if (a[i][j] == '.') {
                    pref_row[i][j] = pref_row[i][j - 1] + 1;
                }
            }
            suff_row[i][m - 1] = (a[i][m - 1] == '.');
            for (int j = m - 2; j >= 0; --j) {
                if (a[i][j] == '.') {
                    suff_row[i][j] = suff_row[i][j + 1] + 1;
                }
            }
        }
        for (int j = 0; j < m; ++j) {
            pref_col[0][j] = (a[0][j] == '.');
            for (int i = 1; i < n; ++i) {
                if (a[i][j] == '.') {
                    pref_col[i][j] = pref_col[i - 1][j] + 1;
                }
            }
            suff_col[n - 1][j] = (a[n - 1][j] == '.');
            for (int i = n - 2; i >= 0; --i) {
                if (a[i][j] == '.') {
                    suff_col[i][j] = suff_col[i + 1][j] + 1;
                }
            }
        }
        int cur_opt = 0;
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                if (a[i][j] == '.') {
                    int res = pref_col[i][j] + pref_row[i][j] + suff_col[i][j] + suff_row[i][j] - 2;
                    res -= min({pref_col[i][j], pref_row[i][j], suff_col[i][j], suff_row[i][j]});
                    cur_opt = max(cur_opt, res);
                }
            }
        }
        return cur_opt;
    };
    int ans = max(cur_opt, get_max_T());
    cout << ans << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int T = 1;
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
    cin >> T;
    for (int t = 0; t < T; ++t) {
        solve();
    }
}
