#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

void input() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout.setf(ios::fixed);
    cout.precision(10);
#ifdef _DEBUG
    freopen("../src/input.txt", "r", stdin);
    freopen("../src/output.txt", "w", stdout);
#endif
}

const int INF = INT_MAX;

void solve();

int main() {
    input();
    solve();
    return 0;
}

#ifndef _DEBUG
#define _DEBUG 0
#endif

const int N = 2e5 + 7;
const int K = 400;
const int MAX_X = 2e6 + 7;

int n, q;
int a[N];
struct Query {
    int p, v;
} qs[N];
set<int> val[MAX_X];
int nxt[N];

int t[4 * N];

void build_t(int pos, int l, int r) {
    if (r - l == 1) {
        t[pos] = a[l];
    } else {
        build_t(2 * pos + 1, l, l + r >> 1);
        build_t(2 * pos + 2, l + r >> 1, r);
        t[pos] = min(t[2 * pos + 1], t[2 * pos + 2]);
    }
}

void upd(int pos, int l, int r, int i, int x) {
    if (i < l || i >= r) {
        return;
    } else if (r - l == 1) {
        t[pos] = x;
    } else {
        upd(2 * pos + 1, l, l + r >> 1, i, x);
        upd(2 * pos + 2, l + r >> 1, r, i, x);
        t[pos] = min(t[2 * pos + 1], t[2 * pos + 2]);
    }
}

int get(int pos, int l, int r, int ql, int qr) {
    if (r <= ql || qr <= l) {
        return INF;
    } else if (ql <= l && r <= qr) {
        return t[pos];
    } else {
        return min(get(2 * pos + 1, l, l + r >> 1, ql, qr),
                   get(2 * pos + 2, l + r >> 1, r, ql, qr));
    }
}

void scan() {
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    a[n] = -1;
    ++n;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        cin >> qs[i].p >> qs[i].v;
    }
}

int get_ans() {
    int res = 0;
    int cur = a[0];
    for (int i = 0; i < n - 1; ++i) {
        cur = min(cur, a[i]);
        res += cur;
    }
    return res;
}

void build() {
    for (int i = 0; i < n - 1; ++i) {
        val[a[i]].insert(i);
    }
    vector<pair<int, int>> min_stack = {{a[n - 1], n - 1}};
    for (int i = n - 2; i >= 0; --i) {
        while (a[i] <= min_stack.back().first) {
            min_stack.pop_back();
        }
        nxt[i] = min_stack.back().second;
        min_stack.push_back({a[i], i});
    }
}

int local_a[N];

set<int> prepare(int i) {
    copy(a, a + n, local_a);
    set<int> res;
    for (int j = i; j < i + K && j < q; ++j) {
        res.insert(qs[j].v);
        res.insert(nxt[qs[j].v]);
        if (qs[j].p == 1) {
            auto elem = val[local_a[qs[j].v]].upper_bound(qs[j].v);
            if (elem != val[local_a[qs[j].v]].end()) {
                res.insert(*elem);
            }
            ++local_a[qs[j].v];
        } else {
            --local_a[qs[j].v];
            if (local_a[qs[j].v] == a[nxt[qs[j].v]]) {
                res.insert(nxt[nxt[qs[j].v]]);
            }
        }
    }
    return res;
}

void upd(int i, int d) {
    val[a[i]].erase(i);
    a[i] += d;
    val[a[i]].insert(i);
    upd(0, 0, n, i, a[i]);
}

int choose_nxt(int i, set<int> &maybe_nxt) {
    int res = n - 1;
    for (int j: maybe_nxt) {
        if (a[i] > a[j] && i < j) {
            res = min(res, j);
        }
    }
    return res;
}

void update_ans(int &ans, int i, set<int> &maybe_nxt, int p) {
    int new_nxt = choose_nxt(i, maybe_nxt);
    if (p == 1 && (i == 0 || get(0, 0, n, 0, i) >= a[i])) {
        ans += new_nxt - i;
    } else if (i == 0 || get(0, 0, n, 0, i) > a[i]) {
        ans -= nxt[i] - i;
    }
    nxt[i] = new_nxt;
}

void solve() {
    scan();
    int ans = get_ans();
    build();
    build_t(0, 0, n);
    cout << ans << '\n';
    for (int i = 0; i < q; i += K) {
        vector<pair<int, int>> min_stack = {{a[n - 1], n - 1}};
        for (int i = n - 2; i >= 0; --i) {
            while (a[i] <= min_stack.back().first) {
                min_stack.pop_back();
            }
            nxt[i] = min_stack.back().second;
            min_stack.push_back({a[i], i});
        }
        set<int> maybe_nxt = prepare(i);
        for (int j = i; j < i + K && j < q; ++j) {
            nxt[qs[j].v] = choose_nxt(qs[j].v, maybe_nxt);
            if (qs[j].p == 1) {
                upd(qs[j].v, +1);
            } else {
                upd(qs[j].v, -1);
            }
            update_ans(ans, qs[j].v, maybe_nxt, qs[j].p);
            cout << ans << '\n';
        }
    }
}