#include <bits/stdc++.h>

#define ll long long
#define fi first
#define se second
#define i128 __int128

const long double PI = acos(-1);
const long double eps = 1e-8;
const int MOD = 1e9 + 7;
const int MOD998 = 998244353;
const int INF = 1e9 + 7;

#define int ll

using namespace std;

struct node {
	int left, right;
	node * child_left, * child_right;
	int mn;
};

node * build (int l, int r, vector <int> & a) {
	node * res = new node;
	res->left = l; res->right = r;
	if (l == r) {
		res->mn = a[l];
		res->child_left = res->child_right = 0;
	}
	else {
		int m = l + (r - l) / 2;
		res->child_left = build(l, m, a);
		res->child_right = build(m + 1, r, a);
		res->mn = min(res->child_left->mn, res->child_right->mn);
	}
	return res;
}

void update (node * root, int ind, int x) {
	if (ind < root->left || ind > root->right)
		return;
	if (root->left == root->right) {
		root->mn = x;
		return;
	}
	update(root->child_left, ind, x);
	update(root->child_right, ind, x);
	root->mn = min(root->child_left->mn, root->child_right->mn);
}

int query (node * root, int l, int r) {
	if (r < root->left || l > root->right)
		return 1e9;
	if (l <= root->left && root->right <= r)
		return root->mn;
	int res1 = query(root->child_left, l, r);
	int res2 = query(root->child_right, l, r);
	return min(res1, res2);
}

void solve();

void opt(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
}
void files(){
	freopen("input.in", "r", stdin);
	freopen("output.out", "w", stdout);
}

main() {
	opt();
	// files();
	int T = 1;
	// cin >> T;
	while (T--) {
		solve();
		// cout << endl;
	}
}

int mex (node * root, vector <int> & a, int val) {
	int n = a.size() - 1;
	if (a[0] <= val) return 0;
	int l = 0, r = n;
	while (r - l > 1) {
		int m = l + (r - l) / 2;
		if (query(root, 0, m) <= val) r = m;
		else l = m;
	}
	return r;
}

void solve() {
	int n; cin >> n;
	vector <int> a(n + 1);
	for (int i = 0; i < n; ++i) cin >> a[i];
	node * root = new node;
	root = build(0, n, a);
	
	int res = 0;
	int curr = a[0];
	for (int i = 1; i < n; ++i) {
		if (a[i] < curr) {
			res += i * (curr - a[i]);
			curr = a[i];
		}
	}
	res += curr * n;
	cout << res << endl;

	int q; cin >> q;
	while (q--) {
		int t, x; cin >> t >> x;
		if (t == 1) {
			// cout << "For current Finding first <= " << a[x] - 1 << endl;
			// cout << "mex = " << mex(root, a, a[x]) << endl;
			res -= mex(root, a, a[x]);
			++a[x];
			update(root, x, a[x]);
			// for (int i = 0; i < 7; ++i)
			// 	cout << "To " << i << " got " << query(root, 0, i) << endl;
			// cout << "For new Finding first <= " << a[x] - 1 << endl;
			// cout << "new mex = " << mex(root, a, a[x]) << endl;
			res += mex(root, a, a[x] - 1);
			cout << res << endl;
		}
		else if (t == 2) {
			// cout << "For current Finding first <= " << a[x] - 1 << endl;
			// cout << "mex = " << mex(root, a, a[x] - 1) << endl;
			res -= mex(root, a, a[x] - 1);
			--a[x];
			update(root, x, a[x]);
			// for (int i = 0; i < 7; ++i)
			// 	cout << "To " << i << " got " << query(root, 0, i) << endl;
			// cout << "For new Finding first <= " << a[x] << endl;
			// cout << "new mex = " << mex(root, a, a[x]) << endl;
			res += mex(root, a, a[x]);
			cout << res << endl;
		}
	}
}