#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <numeric>
#include <queue>

using namespace std;

#define int long long
#define vi vector<int>
#define pii pair<int, int>
#define vec vector
#define double long double

int t[3 * 8 * 100000];
int p[3 * 8 * 100000];
int tt;

void push(int v) {
	if (v >= tt) {
		t[v] += p[v];
		p[v] = 0;
		return;
	}
	p[v * 2] = p[v];
	p[v * 2 + 1] += p[v];
	p[v] = 0;
}

int query(int v, int l, int r, int vl, int vr) {
	if (vl > vr) return 1e9;
	if (l > vr || r < vl) return 1e9;
	if (l <= vl && vr <= r) return t[v];
	//push(v);
	int m = (vl + vr) / 2;
	return min(query(v * 2, l, r, vl, m), query(v * 2 + 1, l, r, m + 1, vr));
}

/*int update(int v, int l, int r, int vl, int vr, int diff) {
	if (vl > vr) return 1e9;
	if (l > vr || r < vl) return t[v];
	if (l <= vl && vr <= r) {
		p[v] += diff;
		return t[v] + p[v];
	}
	int m = (l + r) / 2;
	return t[v] = min(update(v * 2, l, r, vl, m, diff), update(v * 2 + 1, l, r, m + 1, vr, diff));
}*/

void upd(int i, int v) {
	i += tt;
	t[i] = v;
	while (i > 1) {
		i >>= 1;
		t[i] = min(t[i * 2], t[i * 2 + 1]);
	}
}

signed main() {
	int n;
	cin >> n;
	tt = n & (n - 1);
	if (!tt) tt = n;
	tt <<= 1;
	vi a(n), p(n);
	int s = 0;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		p[i] = min(a[i], i ? p[i - 1] : a[i]);
		s += p[i];
	}
	for (int i = 0; i < n; ++i) t[tt + i] = a[i];
	for (int i = tt - 1; i > 0; --i) t[i] = min(t[i * 2], t[i * 2 + 1]);
	vi ans = { s };
	int q;
	cin >> q;
	while (q--) {
		int _, b;
		cin >> _ >> b;
		if (_ == 1) {
			if (b && query(1, 0, b - 1, 0, tt - 1) <= a[b]) {
				++a[b];
				upd(b, a[b]);
				ans.push_back(s);
				continue;
			}

			int left = b, right = n;
			while (left + 1 < right) {
				int mid = (left + right) / 2;
				int seg_min = query(1, b + 1, mid, 0, tt - 1);
				if (seg_min <= a[b]) {
					right = mid;
				}
				else {
					left = mid;
				}
			}
			s += right - b; ++a[b];
			upd(b, a[b]);
		}
		else {
			if (b && query(1, 0, b - 1, 0, tt - 1) < a[b]) {
				a[b]--;
				upd(b, a[b]);
				ans.push_back(s);
				continue;
			}
			int lf = 0, rt = n;
			while (lf + 1 < rt) {
				int md = (lf + rt) / 2;
				if (query(1, 0, md, 0, tt - 1) == a[b]) {
					lf = md;
				}
				else rt = md;
			}
			s -= lf - b + 1; --a[b];
			upd(b, a[b]);
		}
		ans.push_back(s);
	}
	//	cout << "\n";
	for (auto& e : ans) cout << e << "\n";
}