class Cube:
    current_state = [0, 2, 1, 3, 5, 4]
    colors = [-1 for _ in range(6)]
    moving_down = [3, 2, 0, 1, 4, 5]
    moving_right = [5, 4, 2, 3, 0, 1]

    def __init__(self, state, colors):
        if state:
            self.current_state = state
            self.colors = colors
        else:
            self.current_state = [0, 2, 1, 3, 5, 4]
            self.colors = [-1 for _ in range(6)]

    def get_str(self):
        for i in range(6):
            if self.colors[i] == -1:
                self.colors[i] = 0
        t2 = self.colors
        t1 = [t2[0], t2[5], t2[1], t2[3], t2[4], t2[2]]
        return ''.join([str(x) + " " for x in t1])

    def get_str2(self):
        return ''.join([str(x) + " " for x in self.colors])

    def paint_bot(self, col):
        cur_col = self.colors[self.current_state[0]]
        if cur_col != -1 and cur_col != col:
            return False
        self.colors[self.current_state[0]] = col
        return True

    def go_right(self):
        temp = self.current_state.copy()
        for i in range(6):
            temp[i] = self.current_state[self.moving_right[i]]
        return Cube(temp, self.colors)

    def go_down(self):
        temp = self.current_state.copy()
        for i in range(6):
            temp[i] = self.current_state[self.moving_down[i]]
        return Cube(temp, self.colors)


def test():
    n = int(input())
    field = list()
    final_cell = (n-1, n-1)
    for _ in range(n):
        field.append(list(map(int, input().split())))

    cube = go_deep((0, 0), Cube([], []), final_cell, field)
    if cube:
        print("Yes")
        print(cube.get_str())
    else:
        print("No")


def go_deep(cell, cube, final_cell, field):
    n = len(field)
    if cell[0] >= n or cell[1] >= n:
        return None
    if not cube.paint_bot(field[cell[0]][cell[1]]):
        return None
    if cell == final_cell:
        return cube
    cube1 = go_deep((cell[0], cell[1] + 1), cube.go_right(), final_cell, field)
    cube2 = go_deep((cell[0] + 1, cell[1]), cube.go_down(), final_cell, field)
    if cube1:
        return cube1
    if cube2:
        return cube2
    return None


t = int(input())
for _ in range(t):
    test()




