#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

struct hole
{
    int len = 0, line, beg, en;
};

vector<vector<char> > v;
vector<hole> vert, horiz;

bool cmp(hole h1, hole h2)
{
    return h1.len > h2.len;
}

int hor_2()
{
    if (horiz.size() == 0)
    {
        return 0;
    }
    if (horiz.size() == 1)
    {
        return horiz[horiz.size() - 1].len;
    }
    return horiz[0].len + horiz[1].len;
}

int vert_2()
{
    if (vert.size() == 0)
    {
        return 0;
    }
    if (vert.size() == 1)
    {
        return vert[vert.size() - 1].len;
    }
    return vert[0].len + vert[1].len;
}

int hor_mx()
{
    int mx = -1;
    for (int i = 0; (i < horiz.size()) && (horiz[i].len == horiz[0].len); i++)
    {
        for (int j = 0; j < vert.size(); j++)
        {
            if (horiz[i].line > vert[j].en || horiz[i].line < vert[j].beg)
            {
                mx = max(mx, horiz[i].len + vert[j].len);
                break;
            }
            mx = max(mx, horiz[i].len + max(horiz[i].line - vert[j].beg, vert[j].en - horiz[i].line));
        }
    }
    return mx;
}

int vert_mx()
{
    int mx = -1;
    for (int i = 0; (i < vert.size()) && (vert[i].len == vert[0].len); i++)
    {
        for (int j = 0; j < horiz.size(); j++)
        {
            if (vert[i].line > horiz[j].en || vert[i].line < horiz[j].beg)
            {
                mx = max(mx, vert[i].len + horiz[j].len);
                break;
            }
            mx = max(mx, vert[i].len + max(vert[i].line - horiz[j].beg, horiz[j].en - vert[i].line));
        }
    }
    return mx;
}

int main()
{
    int test, n, m;
    cin >> test;
    for (int k = 0; k < test; k++)
    {
        cin >> n >> m;
        v.resize(n, vector<char> (m));
        vert.clear();
        horiz.clear();
        for (int i = 0; i < n; i++)
        {
            for (int j = 0; j < m; j++)
            {
                cin >> v[i][j];
            }
        }
        int cnt = 0;
        hole h;
        bool flag = false;
        for (int i = 0; i < n; i++)
        {
            flag = false;
            for (int j = 0; j < m; j++)
            {
                h.line = i;
                if (v[i][j] == '.')
                {
                    if (j == 0 || v[i][j - 1] == '#')
                    {
                        h.beg = j;
                    }
                    cnt++;
                    flag = true;
                }
                else if (flag)
                {
                    h.en = j - 1;
                    h.len = h.en - h.beg + 1;
                    horiz.push_back(h);
                    flag = false;
                }
            }
            if (v[i][m - 1] != '#')
            {
                h.en = m - 1;
                h.len = h.en - h.beg + 1;
                horiz.push_back(h);
            }
        }
        flag = false;
        for (int j = 0; j < m; j++)
        {
            flag = false;
            for (int i = 0; i < n; i++)
            {
                h.line = j;
                if (v[i][j] == '.')
                {
                    if (i == 0 || v[i - 1][j] == '#')
                    {
                        h.beg = i;
                    }
                    cnt++;
                    flag = true;
                }
                else if (flag)
                {
                    h.en = i - 1;
                    h.len = h.en - h.beg + 1;
                    vert.push_back(h);
                    flag = false;
                }
            }
            if (v[n - 1][j] != '#')
            {
                h.en = n - 1;
                h.len = h.en - h.beg + 1;
                vert.push_back(h);
            }
        }

        /*for (int i = 0; i < horiz.size(); i++)
        {
            cout << horiz[i].line << ' ' << horiz[i].beg << ' ' << horiz[i].en << endl;
        }

        cout << "*************" << endl;

        for (int i = 0; i < vert.size(); i++)
        {
            cout << vert[i].line << ' ' << vert[i].beg << ' ' << vert[i].en << endl;
        }*/

        sort(horiz.begin(), horiz.end(), cmp);
        sort(vert.begin(), vert.end(), cmp);
        cout << max(hor_2(), max(vert_2(), max(hor_mx(), vert_mx()))) << endl;
    }
}

/*

1
4 5
###.#
#....
.##.#
#.#.#

*/
