#include <iostream>
#include <math.h>
#include <limits>
#include <vector>
#include <map>
#include <set>
#include <queue>
using namespace std;

#define pb push_back

void intovec(vector<pair<int, int>>& vec, const int& left, const int& right) {
    int s = right - left + 1;
    if(vec.size() == 0) {
        vec.pb({left, right});
    }
    else if(vec.size() < 2) {
        vec.pb({left, right});
        if(vec[1].second - vec[1].first + 1 > vec[0].second - vec[0].first + 1) {
            swap(vec[0], vec[1]);
        }
    }
    else {
        if(vec[0].second - vec[0].first + 1 < s) {
            vec[1] = vec[0];
            vec[0] = {left, right};
        }
        else if(vec[1].second - vec[1].first + 1 < s) {
            vec[1] = {left, right};
        }
    }
}

void solve() {
    int n, m; cin >> n; cin >> m;
    char wall[n][m];
    vector<vector<pair<int, int>>> gorisontal(n);
    vector<vector<pair<int, int>>> vertical(m);
    int cur = 0;
    for(int i = 0; i < n; i++) {
        cur = 0;
        for(int j = 0; j < m; j++) {
            cin >> wall[i][j];
            if(wall[i][j] == '.')
                cur++;
            else {
                if (cur > 0) intovec(gorisontal[i], j - cur, j - 1);
                cur = 0;
            }
        }
        if(cur > 0) intovec(gorisontal[i], m-cur, m-1);
    }
    for(int j = 0; j < m; j++) {
        cur = 0;
        for(int i = 0; i < n; i++) {
            if(wall[i][j] == '.') {
                cur++;
            }
            else {
                if(cur > 0) intovec(vertical[j], i-cur, i-1);
                cur = 0;
            }
        }
        if(cur > 0) intovec(vertical[j], n-cur, n-1);
    }

    int res = 0;
    int a = 0, b = 0;
    //to only gorisontal
    for(int i = 0; i < n; i++) {
        while(gorisontal[i].size() < 2) {
            gorisontal[i].pb({0, -1});
        }
        int len = gorisontal[i][0].second - gorisontal[i][0].first + 1;
        if(len > a) {
            b = a;
            a = len;
        }
        else if(len > b) {
            b = len;
        }
        res = max(res, a + b);
    }
    //to only vertical
    a = 0, b = 0;
    for(int i = 0; i < m; i++) {
        while(vertical[i].size() < 2) {
            vertical[i].pb({0, -1});
        }
        int len = vertical[i][0].second - vertical[i][0].first + 1;
        if(len > a) {
            b = a;
            a = len;
        }
        else if(len > b) {
            b = len;
        }
        res = max(res, a + b);
    }
    //to vert and diagonal
    for(int i = 0; i < n; i++) {
        int len0 = gorisontal[i][0].second - gorisontal[i][0].first + 1;
        int len1 = gorisontal[i][1].second - gorisontal[i][1].first + 1;
        for(int j = 0; j < m; j++) {
            int len2 = vertical[j][0].second - vertical[j][0].first + 1;
            int len3 = vertical[j][1].second - vertical[j][1].first + 1;
            if(j <= gorisontal[i][0].second && j >= gorisontal[i][0].first) {
                if(i <= vertical[j][0].second && i >= vertical[j][0].first) {
                    res = max(res, len0 + i - vertical[j][0].first);
                    res = max(res, len0 + vertical[j][0].second - i);
                    res = max(res, len2 + j - gorisontal[i][0].first);
                    res = max(res, len2 + gorisontal[i][0].second - j);
                }
                else {
                    res = max(res, len0 + len2);
                }
            }
            else {
                res = max(res, len0 + len2);
            }
            if(j <= gorisontal[i][1].second && j >= gorisontal[i][1].first) {
                if(i <= vertical[j][0].second && i >= vertical[j][0].first) {
                    res = max(res, len1 + i - vertical[j][0].first);
                    res = max(res, len1 + vertical[j][0].second - i);
                    res = max(res, len2 + j - gorisontal[i][1].first);
                    res = max(res, len2 + gorisontal[i][1].second - j);
                }
                else {
                    res = max(res, len1 + len2);
                }
            }
            else {
                res = max(res, len1 + len2);
            }
            if(j <= gorisontal[i][0].second && j >= gorisontal[i][0].first) {
                if(i <= vertical[j][1].second && i >= vertical[j][1].first) {
                    res = max(res, len0 + i - vertical[j][1].first);
                    res = max(res, len0 + vertical[j][1].second - i);
                    res = max(res, len3 + j - gorisontal[i][0].first);
                    res = max(res, len3 + gorisontal[i][0].second - j);
                }
                else {
                    res = max(res, len0 + len3);
                }
            }
            else {
                res = max(res, len0 + len3);
            }
            if(j <= gorisontal[i][1].second && j >= gorisontal[i][1].first) {
                if(i <= vertical[j][1].second && i >= vertical[j][1].first) {
                    res = max(res, len1 + i - vertical[j][1].first);
                    res = max(res, len1 + vertical[j][1].second - i);
                    res = max(res, len3 + j - gorisontal[i][1].first);
                    res = max(res, len3 + gorisontal[i][1].second - j);
                }
                else {
                    res = max(res, len1 + len3);
                }
            }
            else {
                res = max(res, len1 + len3);
            }
        }
    }
    cout << res << endl;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t; cin >> t;
    for(int i = 0; i < t; i++) {
        solve();
    }
    return 0;
}
